import threading
import time

from robotic_arm_package.robotic_arm import *

global speed
global clog

# 机械臂1为左臂2为右臂
arm1 = Arm(RM65, '192.168.10.18')
arm2 = Arm(RM65, '192.168.10.19')


def Robot_Lift():
    # 预备运动
    move_j(arm1, [-45, -70, 0, 0, 0, 0])
    Hand_Seq(arm1, 1)
    Hand_Seq(arm1, 2)
    Hand_Seq(arm1, 1)
    move_j(arm1, [0, -90, 0, 0, 0, 0])

    # 第一段
    Hand_Seq(arm1, 3)
    move_j(arm1, [-45, -70, 0, 0, 0, 0])
    move_j(arm1, [-150, -70, 0, 0, 0, 0])
    Hand_Seq(arm1, 1)
    move_j(arm1, [-175, 0, 0, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])

    # 第二段
    move_j(arm1, [-90, -70, 0, 0, 0, 0])
    Hand_Seq(arm1, 2)
    move_j(arm1, [-90, 70, -120, 0, -25, 0])
    move_j(arm1, [-90, 0, 0, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm1, 1)

    # 第三段
    move_j(arm1, [0, 90, 0, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])
    move_j(arm1, [0, 90, 0, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])

    # 第四段
    move_j(arm1, [0, 0, 90, 0, 0, 0])
    Hand_Seq(arm1, 2)
    move_j(arm1, [0, -55, 115, 0, 30, 0])
    move_j(arm1, [0, 0, 90, 0, 0, 0])
    move_j(arm1, [0, -55, 115, 0, 30, 0])
    move_j(arm1, [0, 0, 90, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm1, 1)

    # 第五段
    Hand_Seq(arm1, 2)
    move_j(arm1, [0, -45, 0, 0, 0, 0])
    move_j(arm1, [-50, -30, -80, -60, -110, 0])
    Hand_Seq(arm1, 1)
    Hand_Seq(arm1, 4)
    Hand_Seq(arm1, 4)
    Hand_Seq(arm1, 1)
    Hand_Seq(arm1, 2)
    move_j(arm1, [0, -45, 0, 0, 0, 0])
    move_j(arm1, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm1, 1)
    print("左臂运动完成")


def Robot_Right():
    # 预备运动
    move_j(arm2, [45, -70, 0, 0, 0, 0])
    Hand_Seq(arm2, 1)
    Hand_Seq(arm2, 2)
    Hand_Seq(arm2, 1)
    move_j(arm2, [0, -90, 0, 0, 0, 0])

    # 第一段
    Hand_Seq(arm2, 3)
    move_j(arm2, [45, -70, 0, 0, 0, 0])
    move_j(arm2, [150, -70, 0, 0, 0, 0])
    Hand_Seq(arm2, 1)
    move_j(arm2, [175, 0, 0, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])

    # 第二段
    move_j(arm2, [90, -70, 0, 0, 0, 0])
    Hand_Seq(arm2, 2)
    move_j(arm2, [90, 70, -120, 0, -25, 0])
    move_j(arm2, [90, 0, 0, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm2, 1)

    # 第三段
    move_j(arm2, [0, 90, 0, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])
    move_j(arm2, [0, 90, 0, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])

    # 第四段
    move_j(arm2, [0, 0, 90, 0, 0, 0])
    Hand_Seq(arm2, 2)
    move_j(arm2, [0, -55, 115, 0, 30, 0])
    move_j(arm2, [0, 0, 90, 0, 0, 0])
    move_j(arm2, [0, -55, 115, 0, 30, 0])
    move_j(arm2, [0, 0, 90, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm2, 1)

    # 第五段
    Hand_Seq(arm2, 2)
    move_j(arm2, [0, -45, 0, 0, 0, 0])
    move_j(arm2, [50, -30, -80, 60, -110, 0])
    Hand_Seq(arm2, 1)
    Hand_Seq(arm2, 4)
    Hand_Seq(arm2, 4)
    Hand_Seq(arm2, 1)
    Hand_Seq(arm2, 2)
    move_j(arm2, [0, -45, 0, 0, 0, 0])
    move_j(arm2, [0, -90, 0, 0, 0, 0])
    Hand_Seq(arm2, 1)
    print("右臂运动完成")


def move_j(robot, joint):
    ret = robot.Movej_Cmd(joint, speed, 0, clog)
    if ret == 0:
        print("运动完成")
    else:
        print("运动规划失败")


def Hand_Seq(robot, num):
    ret = robot.Set_Hand_Seq(num, clog)
    if ret == 0:
        print("运动完成")
    else:
        print("运动规划失败")


if __name__ == "__main__":
    # 设置运动速度
    speed = 30

    # 设置阻塞模式
    clog = True

    # 创建两个线程
    t1 = threading.Thread(name='t1', target=Robot_Lift)
    t2 = threading.Thread(name='t2', target=Robot_Right)

    # 启动两个线程
    t1.start()
    t2.start()

    # 等待两个线程完成
    t1.join()
    t2.join()
